<?php

/**
 * bp_upm_admin()
 *
 * Checks for form submission, saves component settings and outputs admin screen HTML.
 */

add_action( 'admin_init', 'bp_upm_settings' );
function bp_upm_settings() {
	register_setting ( 'bp_wp_upm-settings-group', 'upm_width' );
	register_setting ( 'bp_wp_upm-settings-group', 'upm_height' );
 register_setting ( 'bp_wp_upm-settings-group', 'upm_map_zoom' );
	register_setting ( 'bp_wp_upm-settings-group', 'upm_display_where' );
 register_setting ( 'bp_wp_upm-settings-group', 'upm_navigation_display' );
 register_setting ( 'bp_wp_upm-settings-group', 'upm_navigation_size' );
 register_setting ( 'bp_wp_upm-settings-group', 'upm_members_directory' );
 }
 add_option( 'upm_width', '' );
 add_option( 'upm_height', '' );
 add_option( 'upm_map_zoom', '' );
 add_option( 'upm_display_where', '0' );
 add_option( 'upm_navigation_display', '' );
 add_option( 'upm_navigation_size', '' );
 add_option( 'upm_members_directory', '' );
function bp_upm_admin() {
	global $bp;

	/* If the form has been submitted and the admin referrer checks out, save the settings */
	if ( isset( $_POST['submit'] ) && check_admin_referer('update_upm_settings', 'upm_settings') ) {
		update_option( 'upm_width', $_POST['width'] );
		update_option( 'upm_height', $_POST['height'] );
  update_option( 'upm_display_where', $_POST['upm_display_where'] );
  update_option( 'upm_map_zoom', $_POST['upm_map_zoom'] );
  update_option( 'upm_navigation_display', $_POST['upm_navigation_display'] );
  update_option( 'upm_navigation_size', $_POST['upm_navigation_size'] );
  update_option( 'upm_map_type_control', $_POST['upm_map_type_control'] );
  update_option( 'upm_members_directory', $_POST['upm_members_directory'] );

		$updated = true;
	}


	$map_width = get_option( 'upm_width' );
	$map_height = get_option( 'upm_height' );
 $map_zoom   =  get_option('upm_map_zoom' );
 $navigation_display   =  get_option( 'upm_navigation_display' );
 $navigation_size = get_option( 'upm_navigation_size' ); 
 $map_type_control = get_option( 'upm_map_type_control' );
 $set_members_dir = get_option( 'upm_members_directory' );
  
  function checked_radio($num) {
   global $bp;
   $radio_item = $num;
   $radio_selection = get_option( 'upm_display_where' );
   if ($radio_selection !== $radio_item )
   return false;
   else
   echo  'checked="checked"';
   return; 
   }
   
?>
	<div class="wrap">
		<h2><?php _e( 'User Profile Map Settings Admin', 'bp-upm' ) ?></h2>
		

		<?php if ( isset($updated) ) : ?><?php echo "<div id='message' class='updated fade'><p>" . __( 'Settings Updated.', 'bp-upm' ) . "</p></div>" ?><?php endif; ?>
     <p><?php _e('To use profile maps either displayed through page action hooks using the radio selections below or via the widget you must have first set up a new custom xprofile field called <b>Location</b> This is important as the map script looks for this field and value to obtain map location data.', 'bp_upm') ?></p>
     <p><?php _e("If you have not yet set up a location field please visit the <a href=\"" .  $path_to ."?page=bp-profile-setup\">Profile Field Setup</a> page.", "bp_upm") ?></p>
     <p><?php _e('You can either set the location field in the base group to show it on the sign up page or create a new group for the field name in which case it will show in the users profle setup and public display only.', 'bp_upm') ?></p>
		<form action="<?php echo  $path_to  . '?page=bp-upm-settings' ?>" name="upm-settings-form" id="upm-settings-form" method="post">
   
			<p><?php _e('Styling of the map elements is kept to a minimum, you might need to add styles for your theme via a child theme style.css sheet.', 'bp_upm') ?></p>
   
   <h3><?php _e('Map configuration options', 'bp-upm') ?></h3>
   
   <p><b><?php _e('Set map dimensions - Note: you may set the height only for proportional width or set both values.', 'bp_upm') ?> </b></p>
     <table class="form-table">
		    <colgroup>
       <col span="1" width="30%" />
       <col span="1" width="70%" />
      </colgroup>		
      <tr valign="top">
					  <th scope="row"><label for="upm-width"><?php _e( 'Map width (e.g 300 to  = 300px)', 'bp-upm' ) ?></label></th>
					  <td>
						 <input name="width" type="text" id="upm-width"  value="<?php echo attribute_escape( $map_width ); ?>" size="20" />
					  </td>
				  </tr>
      <tr>
					  <th scope="row"><label for="upm-height"><?php _e( 'Map height', 'bp-upm' ) ?></label></th>
					  <td>
						  <input name="height" type="text" id="upm-height" value="<?php echo attribute_escape( $map_height ); ?>" size="20" />
					  </td>
				  </tr>
      <tr><td colspan="2"><?php _e('If no map dimensions are set here the map will default to display at a width and height of 200px', 'bp-upm') ?></td></tr>
      <tr valign="top">
					  <th scope="row"><label for="upm-zoom"><?php _e( 'Map Zoom', 'bp-upm' ) ?></label></th>
					  <td>
						 <input name="upm_map_zoom" type="text" id="upm-zoom" maxlength="2" value="<?php echo attribute_escape( $map_zoom ); ?>" size="5" />
					  </td>
      <tr valign="top">
       <td colspan="2"><?php _e('Map zoom sets the level of detail shown on the map, the higher the value the more you zoom into the location. Values between 8 &amp; 16 work well. If no value set Zoom value defaults to 11.', 'bp-upm') ?></td></tr>       
      </tr>
      <tr>
       <th scope="row"><label for="map-navigation"><?php _e( 'Show the map navigation overlay controls. ', 'bp-upm' ) ?></label></th>
       <td><input  name="upm_navigation_display" type="checkbox" id="map-navigation" <?php if( $navigation_display == true){?> checked="checked" <?php } ?>  value= true /></p></td>
      </tr>
      <tr>
       <td colspan="2"><?php _e('If you want to display a set of navigation controls, i.e zoom, pan etc then check the box above to  show these controls on the maps.', 'bp-upm');  ?></td>
      </tr>
      <tr>
       <th scope="row" valign="top"><label for="navigationSmall"><?php _e( 'Set the map navigation control size to small. ', 'bp-upm' ) ?></label></th>
       <td><input  name="upm_navigation_size" type="checkbox" id="navigationSmall" <?php if( $navigation_size == 'small'){?> checked="checked" <?php } ?>  value= 'small' /></p></td>
      </tr>
      <tr valign="top">
       <td colspan="2"><?php _e('Google maps adjusts certain map controls according to the maps dimensions  I.E the larger the map the more complex and larger the controls will be. If you wish to keep the navigation controls fixed as small check the box above.', 'bp-upm');  ?></td>
      </tr>
      <tr>
       <th scope="row" valign="top"><label for="map-type-control"><?php _e( 'Set map type control as a dropdown', 'bp-upm' ) ?></label></th>
       <td><input  name="upm_map_type_control" type="checkbox" id="map-type-control" <?php if( $map_type_control == 'dropdown'){?> checked="checked" <?php } ?>  value= 'dropdown' /></p></td>
      </tr>
      <tr valign="top">
       <td colspan="2"><?php _e('Map type controls select the map view I.E. Map, Satellite, Hybrid, these selections default to dropdown for small maps and inline boxes for larger maps. If you would like to display as a dropdown only then check the box above', 'bp-upm');  ?></td>
      </tr>
     </table>
    
    <h3><?php _e('Page display options', 'bp-upm') ?></h3>
    
    <p><b><?php _e('Select the area of the members account /profile page you would like to display the map in N.B defaults to no region', 'bp_upm') ?></b></p>

				<p><label for="upm-region-none"><?php _e( 'Do not display ', 'bp-upm' ) ?></label>
					
						<input name="upm_display_where" type="radio" id="upm-region-none" <?php checked_radio('0') ?> value="0"  /></p>
               
					<p><label for="upm-region-a"><?php _e( 'bp_before_member_header_meta <i>Will display before header meta to the right.</i>', 'bp-upm' ) ?></label>
					
						<input name="upm_display_where" type="radio" id="upm-region-a" <?php checked_radio('1') ?>  value="1"  /></p>
					
	     <p><label for="upm-region-b"><?php _e( 'bp_profile_header_meta <i>Will display after the header meta.</i>', 'bp-upm' ) ?></label>
					
						<input name="upm_display_where" type="radio" id="upm-region-b" <?php checked_radio('2') ?>  value="2"  /></p>
        
	     <p><label for="upm-region-c"><?php _e( 'bp_after_member_header <i>Displays after the members header content.</i>', 'bp-upm' ) ?></label>
				
						<input name="upm_display_where" type="radio" id="upm-region-c" <?php checked_radio('3') ?>  value="3"  /></p>
        
	     <p><label for="upm-region-d"><?php _e( 'bp_before_loop_content <i>Displays on the members public profile view to the right.</i>', 'bp-upm' ) ?></label>
					
						<input name="upm_display_where" type="radio" id="upm-region-d" <?php checked_radio('4') ?>  value="4" /></p>
       <p><b><?php _e('Set checkbox to display map on the members directory listings: this is a work in progress if  indeed possible! Currently disabled.', 'bp_upm') ?> </b></p>
			  
       <p><label for="upm-members-listing"><?php _e( 'Members directory listing page ', 'bp-upm' ) ?></label>
					
						<input disabled="disabled" name="upm_members_directory" type="checkbox" id="upm-members-listing" <?php if( $set_members_dir == 'yes'){?> checked="checked" <?php } ?>  value="yes" /></p>
     
     <p class="submit">
				<input type="submit" name="submit" value="<?php _e( 'Save Settings', 'bp-upm' ) ?>"/>
			</p>

			<?php
			/* This is very important, don't leave it out. */
			wp_nonce_field( 'update_upm_settings', 'upm_settings' );
			?>
		</form>
	</div>
<?php
}
/* pointless comment to force a new revision and commit */
?>