<?php 
global $bp;
define ( 'BP_UPM_DB_VERSION', '1.2' );
/**
* create url paths for multisite network admin screens or plain vanills admin screen
* workaround for adding links to various other site admin pages e.g linking to
* the BP extended profile screen.
* this is  likely a bad hack  with a better solution to be implemented given time.
*/
if( is_multisite() && function_exists( 'is_network_admin' ) ){
$path_to = site_url() . "/wp-admin/network/admin.php";
} else {
$path_to = site_url() . "/wp-admin/admin.php";
}
  
require( dirname( __FILE__ ) . '/upm-widget.php' );
require ( dirname( __FILE__ ) . '/upm-classes.php' );

function upm_add_styles() {

   $style_url = WP_PLUGIN_URL . '/bp-user-profile-map/upm.css';
        $style_file = WP_PLUGIN_DIR . '/bp-user-profile-map/upm.css';
        if (file_exists($style_file)) {
            wp_register_style('upm-style', $style_url);
            wp_enqueue_style('upm-style');
        }
    
}
add_action( 'wp_print_styles', 'upm_add_styles' );

function upm_setup_globals() {
	global $bp, $wpdb;

	/* For internal identification */
	$bp->upm->id = 'upm';
 
	//$bp->upm->format_notification_function = 'bp_upm_format_notifications';
	//$bp->upm->slug = 'user-location';

	/* Register this in the active components array */
	//$bp->active_components[$bp->upm->slug] = $bp->upm->id;
}

//add_action( 'bp_setup_globals', 'bp_upm_setup_globals' );
 /* network_admin_menu */
add_action( 'wp', 'upm_setup_globals', 2 );
if( is_multisite() && function_exists( 'is_network_admin' ) ):
add_action( 'network_admin_menu', 'upm_setup_globals', 2 );
else:
add_action( 'admin_menu', 'upm_setup_globals', 2 );
endif;

################## create the Admin dashboard settings ############
/** create WP admin settings ***/
function bp_upm_menu() {
	global $bp;

  if ( true == $bp->loggedin_user->is_super_admin ):
   $user_is_admin = true;
  elseif (true == $bp->loggedin_user->is_site_admin ):
   $user_is_admin = true;
  else:
   $user_is_admin = false;
  endif;
    
	if ( !$user_is_admin )
		return false;

    require_once( dirname( __FILE__ ) . '/admin/upm-admin.php' );

	add_submenu_page( 'bp-general-settings', __( 'UPM setup', 'bp-upm' ), __( 'UPM Setup', 'bp-upm' ), 'manage_options', 'bp-upm-settings', 'bp_upm_admin' );
}
if( is_multisite() && function_exists( 'is_network_admin' ) ):
add_action( 'network_admin_menu', 'bp_upm_menu' );
else:
add_action( 'admin_menu', 'bp_upm_menu' );
endif;

// Fetch values for map page location & members directory - currently unused.
$where = get_option( 'upm_display_where' );
$members_listing = get_option( 'upm_members_directory' );
  

#### Profile location maps - google V3 api no api key required ####
?>
<?php function member_profile_locationMap(){  
 
  global $bp, $wpdb;

 ?> 
 <?php 
 /**
 * To be worked on.
 * if members directory get members profile data instead of single profile field
 */
/* if (bp_is_page('members'))
   if ( $location =  bp_get_member_profile_data( 'field=Location&user_id=' . bp_the_member())  ): */
   
 if ( $location = bp_get_profile_field_data( 'field=Location&user_id=' . bp_displayed_user_id() ) ):
	
	if ( get_option('upm_width') ) {
	   $map_width = get_option( 'upm_width' );
	} elseif ( empty($map_width) ) {
	   $map_width = '200';
	}
	if ( get_option('upm_height')  ) {
	   $map_height = get_option( 'upm_height' );
	} elseif ( empty($map_height) ) {
	   $map_height = '200';
	}
 if ( get_option('upm_map_zoom') ){
    $map_zoom = get_option( 'upm_map_zoom' ); 
 } elseif ( empty($map_zoom) ){
    $map_zoom = 11;
 } 
 // Create a class for parent map div $where variable sets additional tokens
 $where = get_option('upm_display_where');
 switch($where){
 case "1":
 $whereClass = ' before-header-meta';
 break;
 case "2":
 $whereClass = ' after-header-meta';
 break;
 case "3":
 $whereClass = ' after-header-content';
 break;
 case "4":
 $whereClass = ' profile-loop';
 default:
 $whereClass = '';
 }
 $map_tokens = 'map-display' . $whereClass;
 
 $map_navigation = get_option( 'upm_navigation_display' );
 $navigation_size = get_option( 'upm_navigation_size' );
 $map_type_control = get_option( 'upm_map_type_control' ) ;
 ?>
  <div class="<?php echo $map_tokens; ?>">
   <p class="map-title">Location <?php if (  bp_is_my_profile() ) : ?> . <a href="<?php echo bp_loggedin_user_domain() .'profile/edit/' ?>">Edit</a><?php endif; ?></p>
  <script src="http://maps.google.com/maps/api/js?sensor=false" type="text/javascript"></script>
  <script type="text/javascript">
      
  var geocoder;
  var map;
  function initialize() {
    geocoder = new google.maps.Geocoder();
       var latlng = new google.maps.LatLng(-34.397, 150.644);
       var myOptions = {
       zoom: <?php echo $map_zoom; ?>,
       center: latlng,
       <?php if ( true == $map_navigation  ) {?>
       navigationControl: true,
       <?php   } else { ?>
       navigationControl: false,
       <?php  } ?>
       <?php if ('small' == $navigation_size): ?>
       navigationControlOptions: {
       style: google.maps.NavigationControlStyle.SMALL
       },
       <?php endif; ?> 
       <?php if ('dropdown' == $map_type_control): ?>
       mapTypeControl: true,
       mapTypeControlOptions: {
       style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
       },
       <?php endif; ?> 
       mapTypeId: google.maps.MapTypeId.ROADMAP
       }
     map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
  }      
  function showAddress(address) {
    geocoder.geocode( { 'address': address}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
        map.setCenter(results[0].geometry.location);
        var marker = new google.maps.Marker({
            map: map, 
            position: results[0].geometry.location
        });
      } else {
        alert("Geocode was not successful for the following reason: " + status);
      }
    });
  }      
      
  jQuery(document).ready( function() { initialize(); showAddress('<?php echo $location ?>'); } );

  </script>

  <div id="map_canvas" style="width: <?php echo $map_width; ?>px; height: <?php echo $map_height; ?>px;"></div>
  </div>
  <?php endif;
  }
  
  if ( $where == '1') 
    add_action('bp_before_member_header_meta', 'member_profile_locationMap', 10);
  if ( $where  == '2')
    add_action('bp_profile_header_meta', 'member_profile_locationMap', 10);
  if (  $where == '3')
    add_action('bp_after_member_header', 'member_profile_locationMap', 10); 
  if (  $where == '4')
  //  $map_tokens = $map_tokens . ' profile-loop';
    add_action('bp_before_profile_loop_content', 'member_profile_locationMap', 10);
  /**
  * ToDo: work out how to loop map data in members directory listing page 
  */
  /* if (  $members_listing == 'yes')
    add_action('bp_directory_members_item', 'member_profile_locationMap'); */

?>